
#include "string.h"
#include <stdlib.h>
#include "protocol.h"
#include "malloc.h"
#include "gateway_message.h"

GATEWAY_PARAMS gateway_config_params = {0};

GATEWAY_PARAMS *get_gateway_config_params()
{
    return &gateway_config_params;
}

void parseStringField(const char *data, const char *field, char *value);
int parseIntField(const char *data, const char *field);
void addNode(char *nodestring);
void addDevice(char *string, NODE_PARAMS *node);
int extract_substring(const char *input_string, const char *start_token, const char *end_token, char *result);
void addSensorListParams(char *paramString, DEVICE_PARAMS *device);
void addCommandListParams(char *paramString, DEVICE_PARAMS *device);
/**
 * @brief  ַؽṹϢݱ
 * @param  char *nodestring ַ
 * @retval 
 */
void addGatewayParams(char *gatewayString)
{
    parseStringField(gatewayString, "\"commandTopic\":\"", (char *)&gateway_config_params.commandTopic);
    parseStringField(gatewayString, "\"messageTopic\":\"", (char *)&gateway_config_params.messageTopic);
    parseStringField(gatewayString, "\"deviceId\":\"", (char *)&gateway_config_params.deviceId);
    parseStringField(gatewayString, "\"host\":\"", (char *)&gateway_config_params.host);
    gateway_config_params.port = parseIntField(gatewayString, "\"port\":");
    gateway_config_params.node_params = NULL;
    gateway_config_params.pollTime = parseIntField(gatewayString, "\"pollTime\":");
	  char *nodeString = strstr(gatewayString,"nodeList");  //λõڵݿʼ    
		
    while (1)
    {
      addNode(nodeString);
			nodeString=nodeString;
			nodeString=strstr(nodeString,"}");
			nodeString[0]='A';
			nodeString++;
			if(nodeString[0]==']')//־
			{
				break;
			}
    }

}

/**
 * @brief  ַڵϢ,˽ڵϢؽṹĽڵ
 * @param  char *nodestring
 * @retval 
        עnodeڰ豸device_1ڱĽڵҲܰڽڵʱҪȽݽȡƥ䲻Խ絽Ľڵ
 */

void addNode(char *nodestring)
{
    // һڵ豸Ľڵ
    char *deviceString = (char *)nodestring; // λdevice豸Ϣ
    NODE_PARAMS *newNode = malloc(sizeof(NODE_PARAMS));
    newNode->device_params = NULL; // Ƚ豸ΪNULL
    newNode->nextNode = NULL;      // һ豸ĹΪNULL
	  char nodeIdString[5];
    parseStringField(nodestring, "\"nodeId\":\"", (char *)&nodeIdString);
    for (int j = 0; j < 2; j++)
    {
      uint8_t byte;
      sscanf((const char *)&nodeIdString[j * 2], "%2hhx", &byte);
      newNode->node_address[j]=byte;
    }
    newNode->RFFrequency = parseIntField(nodestring, "\"RFFrequency\":");
    newNode->SignalBw = parseIntField(nodestring, "\"SignalBw\":");
    newNode->SpreadingFactor = parseIntField(nodestring, "\"SpreadingFactor\":");
    newNode->ErrorCoding = parseIntField(nodestring, "\"ErrorCoding\":");
		
		deviceString=strstr(nodestring,"deviceList");//λõ豸ʼ
    while (1)
    {
        if (deviceString)
        {
           addDevice(deviceString, newNode); // ˽ڵ¹豸Ϣ
           deviceString=deviceString;//»ȡ豸ַλ
					 deviceString = strstr(deviceString, "}"); 
					 deviceString[0]='A';
					 deviceString++;
					 if(deviceString[0]==']')
					 {
						 break;
					 }
        }
        else
        {
            return;
        }
        /* code */
    }
 

    // ӽڵ㵽
    if (gateway_config_params.node_params == NULL)
    {
        gateway_config_params.node_params = newNode;
    }
    else
    {
        NODE_PARAMS *current = gateway_config_params.node_params;
        while (current->nextNode != NULL)
        {
            current = current->nextNode;
        }
        current->nextNode = newNode;
    }
}
/**
 * @brief  ֶεַڸýڵµ豸Ϣ
 * @param  uint8_t *stringַ,NODE_PARAMS *nodeڵϢ
 * @retval 
 */
void addDevice(char *deviceString, NODE_PARAMS *node)
{
    char *paramString = (char *)deviceString; // ָ
    // 豸ҳ
    DEVICE_PARAMS *newDevicePage = (DEVICE_PARAMS *)malloc(sizeof(DEVICE_PARAMS));
    newDevicePage->nextDevice = NULL;
    parseStringField(deviceString, "\"deviceId\":\"", (char *)&newDevicePage->deviceID);
    newDevicePage->protocol = parseIntField(deviceString, "\"protocol\":");
    newDevicePage->params = (PARAMS_PROTOCOL_COMMAND *)malloc(sizeof(PARAMS_PROTOCOL_COMMAND));

    paramString = strstr(paramString, "\"sensorData\":["); // ҵýڵѯϷ
    while (1)                                              // ˴ʽ洢Խ治һ
    {
        addSensorListParams(paramString, newDevicePage); // һԲظڸ
				paramString=paramString;
        paramString = strstr(paramString, "}");          // ƶһ
				paramString[0]='A';
        paramString++;
        if (paramString[0] == ']')
        {
            paramString = (char *)deviceString; // ԭָλ
            break;                              // ҵ˽ѭ
        }
    }
		if(newDevicePage->protocol==MODBUS)  //ΪmodbusĻдָ
		{
			paramString=deviceString;                                //ƶʼĵط
			newDevicePage->MDBbigLittleFormat = parseIntField(paramString, "\"bigLittleFormat\":");
      newDevicePage->MDBdataType= parseIntField(paramString, "\"dataType\":");
		  paramString = strstr(paramString, "\"commandData\":["); // ҵѯд
			if(paramString!=NULL)
			{
				while(1)
				{
					addCommandListParams(paramString, newDevicePage);
					paramString = strstr(paramString, "}");
				  paramString[0]='A';
					paramString++;
					if (paramString[0] == ']')
					{
						paramString = (char *)deviceString;
						break;
					}
				}
			}
		}
    // ·mqtt洢Ϣ·ָ
		
    // 豸ҳĩβ
    if (node->device_params == NULL)
    {
        node->device_params = newDevicePage;
    }
    else
    {
        DEVICE_PARAMS *current = node->device_params;
        while (current->nextDevice != NULL)
        {
            current = current->nextDevice;
        }
        current->nextDevice = newDevicePage;
    }
		//modbus commandָص豸
		
}
/**
 * @brief  ַparamString,ݱ浽豸ṹ£˴sensorList
 * @param  uint8_t *paramStringַ,DEVICE_PARAMS *deviceڵϢ
 * @retval 
 */
void addSensorListParams(char *paramString, DEVICE_PARAMS *device)
{
    switch (device->protocol)
    {
    case DLT645_97:
    case DLT645_07:
		{
        NODE_READ_DLT645_COMMAND *read_dlt645_command = malloc(sizeof(NODE_READ_DLT645_COMMAND));
        read_dlt645_command->Identification = parseIntField(paramString, "\"identifier645\":");
        parseStringField(paramString, "\"identifier\":\"", (char *)&read_dlt645_command->keyword);
        char *string = mymalloc(SRAMIN, 13);
        parseStringField(paramString, "\"deviceID645\":\"", string);
        for (int j = 0; j < 6; j++)
        {
          uint8_t byte;
          sscanf((const char *)&string[j * 2], "%2hhx", &byte);
          read_dlt645_command->deviceID645[j]=byte;
        }
        myfree(SRAMIN, string);
        if (device->params->node_read_dlt645_command == NULL)
        {
            device->params->node_read_dlt645_command = read_dlt645_command;
        }
        else
        {
            NODE_READ_DLT645_COMMAND *current = device->params->node_read_dlt645_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_dlt645_command;
        }
			}
        break;
    case MODBUS:
		{
        NODE_READ_MODBUS_COMMAND *read_modbus_command = malloc(sizeof(NODE_READ_MODBUS_COMMAND));
				parseStringField(paramString,"\"identifier\":\"",(char *)&read_modbus_command->keyword);
        read_modbus_command->decimalPoint = parseIntField(paramString, "\"precise\":");
        read_modbus_command->functionCode = parseIntField(paramString, "\"rFunctionCode\":");
        read_modbus_command->slaveAddress = parseIntField(paramString, "\"slaveAddress\":");
        read_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
        read_modbus_command->registerByteNum = parseIntField(paramString, "\"registerByteNum\":");
        if (device->params->node_read_modbus_command == NULL)
        {
            device->params->node_read_modbus_command = read_modbus_command;
        }
        else
        {
            NODE_READ_MODBUS_COMMAND *current = device->params->node_read_modbus_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_modbus_command;
        }
			}
        break;
    default:
        break;
    }
}
/**
 * @brief  ַparamString,ݱ浽豸ṹ£˴commandList
 * @param  uint8_t *paramStringַ,DEVICE_PARAMS *deviceڵϢ
 * @retval 
 */
void addCommandListParams(char *paramString, DEVICE_PARAMS *device)
{
	
 	NODE_WRITE_MODBUS_COMMAND *write_modbus_command=malloc(sizeof(NODE_WRITE_MODBUS_COMMAND));
	parseStringField(paramString,"\"identifier\":\"",(char *)&write_modbus_command->keyword);

	write_modbus_command->functionCode=parseIntField(paramString, "\"wFunctionCode\":");
	write_modbus_command->slaveAddress=parseIntField(paramString, "\"slaveAddress\":");
	write_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
	if(device->params->node_write_modbus_command == NULL)
	{
		device->params->node_write_modbus_command=write_modbus_command;
	}
	else
	{
		NODE_WRITE_MODBUS_COMMAND *current=device->params->node_write_modbus_command;
    while (current->nextParams != NULL)
    {
      current = current->nextParams;
    }
    current->nextParams = write_modbus_command;		
	}
}
// ȡint
int parseIntField(const char *data, const char *field)
{
    char *ptr = strstr(data, field) + strlen(field);
    int value;
    value = strtol(ptr, &ptr, 10);
    return value;
}

// ȡstringַ
void parseStringField(const char *data, const char *field, char *value)
{
    char *ptr = strstr(data, field) + strlen(field);
    sscanf(ptr, "%[^\"],", value);
}

// jsonӲjson
void processStringJson(uint8_t *data)
{
    GATEWAY_PARAMS *gateway;
    gateway = get_gateway_config_params();
    uint8_t *ptr = (uint8_t *)data;
    parseStringField((char *)&ptr, "\"messageTopic\":\"", (char *)&gateway->messageTopic);
    parseStringField((char *)&ptr, "\"commandTopic\":\"", (char *)&gateway->commandTopic);
    gateway->port = parseIntField((char *)&ptr, "\"port\":\"");
    parseStringField((char *)&ptr, "\"host\":\"", (char *)&gateway->host);
    parseStringField((char *)&ptr, "\"deviceId\":\"", (char *)&gateway->deviceId);
    // ,ռ洢ڵϢ

    int nodeNum = 1;
    char *node_index = malloc(10);
    sprintf(node_index, "node_%d", nodeNum);
    strstr(ptr, node_index); // ָָһڵ
    while (*ptr == NULL)
    {

    }
    free(node_index);
}
/**
 * @brief  input_stringѰҿʼλõַݣݽȡresult;
 * @param  input_stringַstart_tokenַʼλãend_tokenַλãresultȡַ
 * @retval 0:ûбȡַ1бȡַ
 */
int extract_substring(const char *input_string, const char *start_token, const char *end_token, char *result)
{
    const char *start_ptr = strstr(input_string, start_token);

    if (start_ptr == NULL)
    {
        return 0; // δҵʼ
    }

    start_ptr += strlen(start_token); // ƶָ뵽ʼ֮

    const char *end_ptr = strstr(start_ptr, end_token);

    if (end_ptr == NULL)
    {
        // δҵǣʼǿʼַһֱƵ \0 
        strcpy(result, start_ptr);
    }
    else
    {
        // ҵǣȡĳȲ
        size_t length = end_ptr - start_ptr;
        strncpy(result, start_ptr, length);
        result[length] = '\0'; // ַ
    }
    return 1;
}
